static Handle:hCvarParachuteModel;

stock wS_ServerVars()
{
	new Handle:hCvar			= CreateConVar("vip_air_jump_power",	"350.0",	"Сила прыжка в воздухе", _, true, 50.0);
	g_fAirJumpPower				= GetConVarFloat(hCvar);
	HookConVarChange(hCvar,		cvar_changed);

	hCvar						= CreateConVar("vip_air_jump_all",		"0",		"1 = Двойной прыжок для всех игроков\n0 = Нет");
	g_bModuleForAll[air_jumps]	= GetConVarBool(hCvar);
	HookConVarChange(hCvar,		cvar_changed);

	hCvar						= CreateConVar("vip_bhop_all",			"0",		"1 = Распрыг для всех игроков\n0 = Нет");
	g_bModuleForAll[bhop]		= GetConVarBool(hCvar);
	HookConVarChange(hCvar,		cvar_changed);

	hCvar						= CreateConVar("vip_parachute_all",		"0",		"1 = Парашут для всех игроков\n0 = Нет");
	g_bModuleForAll[parachute]	= GetConVarBool(hCvar);
	HookConVarChange(hCvar,		cvar_changed);

	hCvar						= CreateConVar("vip_parachute_fire",	"1",		"1 = Парашут с эффектом огня (не работает на v34)\n0 = Нет");
	g_bParachuteFire			= GetConVarBool(hCvar);
	HookConVarChange(hCvar,		cvar_changed);
	
	hCvarParachuteModel			= CreateConVar("vip_parachute_model",	"",			"Путь к модели (models/...mdl) или оставьте пустым");
	
	hCvar						= CreateConVar("vip_parachute_color",	"0 0 0 255","Цвет парашута \"r g b a\" (0 = стандарт)");
	GetColorFromCvar(hCvar,		g_ParachuteColor);
	HookConVarChange(hCvar,		cvar_changed);
	
	hCvar						= CreateConVar("vip_parachute_gravity",	"0.1",		"Сила тяжести при раскрытом парашуте", _, true, 0.01, true, 0.8);
	g_fParachuteGravity			= GetConVarFloat(hCvar);
	HookConVarChange(hCvar,		cvar_changed);
	
	AutoExecConfig(true,		"jumps_parachute",	"vip/modules/jumps_parachute");
}

public cvar_changed(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	decl String:CvarName[32];
	GetConVarName(hCvar,		CvarName,			sizeof(CvarName));
	strcopy(CvarName,			sizeof(CvarName),	CvarName[4]);
	if (!strcmp(CvarName,		"air_jump_power",	false)) g_fAirJumpPower		= StringToFloat(NewValue);
	else if (!strcmp(CvarName,	"parachute_fire",	false)) g_bParachuteFire	= StringToInt(NewValue) == 1;
	else if (!strcmp(CvarName,	"air_jump_all",		false)) ForAll(air_jumps,	StringToInt(NewValue)	== 1);
	else if (!strcmp(CvarName,	"bhop_all",			false)) ForAll(bhop,		StringToInt(NewValue)	== 1);
	else if (!strcmp(CvarName,	"parachute_all",	false)) ForAll(parachute,	StringToInt(NewValue)	== 1);
	else if (!strcmp(CvarName,	"parachute_color",	false)) GetColorFromCvar(hCvar, g_ParachuteColor);
	else if (!strcmp(CvarName,	"parachute_gravity",false)) g_fParachuteGravity	= StringToFloat(NewValue);
}

static ForAll(VipModule:module, bool:bForAll)
{
	if (!g_ItemID[module])
		return;

	if ((g_bModuleForAll[module] = bForAll) && (VIP_GetItemFlags(g_ItemID[module]) & VIP_ITEM_MAPDISABLED))
		g_bModuleForAll[module]  = false; // временно для цикла
	
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client) && (VIP_GetFlags(client) & VCF_AUTHORIZED) && !VIP_HaveAccessToItem(client, g_ItemID[module]))
		{
			if (g_bModuleForAll[module])
			{
				g_bAccess[client][module] = 1;
				if (module == air_jumps) g_AirJumpsLeft[client] = 1;
			}
			else
			{
				g_bAccess[client][module] = 0;
				if (module == parachute) wS_ClearParachute(client);
				else if (module == air_jumps) g_AirJumpsLeft[client] = 0;
			}
			
			if (IsPlayerAlive(client))
				wS_RunCmd(client);
		}
	}
	
	g_bModuleForAll[module] = bForAll;
}

public OnConfigsExecuted()
{
	GetConVarString(hCvarParachuteModel, g_sParachuteModel, sizeof(g_sParachuteModel));
	mdl(g_sParachuteModel, sizeof(g_sParachuteModel), true);
}